local _G = GLOBAL

local TUNING = _G.TUNING

TUNING.ARMOR_VORTEX_CLOAK_COOLDOWN = 5
TUNING.ARMOR_VORTEX_CLOAK_SHIELD_DURATION = 10 * _G.FRAMES
TUNING.ARMOR_VORTEX_CLOAK_FIRST_COOLDOWN = 1

local function overwrite(tabula, name, func)
	if type(tabula) ~= "table" then return end 
	local old = tabula[name]
	tabula[name] = function(...)
		local results = {func(...)}
		local unpack = unpack or table.unpack or _G.unpack
		if #results > 0 then return unpack(results) end 
		if type(old) == "function" then return old(...) end 
	end 
end 

AddComponentPostInit("inventory", function(self)
	overwrite(self, "ApplyDamage", function(self, damage, attacker, weapon)
		local cloak = self.inst._armorvortexcloak 
		if cloak and cloak:CanBlock() then 
			cloak:OnBlocked() 
			return 0
		end  
	end)
end)